module Textplacer
  class Processor
    attr_reader :source, :context

    def initialize(source, context)
      @source = source
      @context = context
    end

    def perform
      process_lists
      process_items
      source
    end

    private

    def process_lists
      lists = source.scan /(\[\[(.+)\]\](.+)\[\[\2\]\])/m
      lists.each do |gsource, key, source|
        localcontext = context.indifferent_fetch(key)
        replace = ''
        localcontext.each do |cont|
          replace += Processor.new(source, cont).perform
        end
        @source.sub! gsource, replace
      end
    end

    def process_items
      @source = ItemProcessor.new(source, context).perform
    end
  end
end
